import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
from lmfit import Model
from pandas_ods_reader import read_ods

# format suboru , v ktorom su ulozene data
file = 'data.xlsx'
#file = 'data.csv'
#file = 'data.ods'

def fit_funkcia(x, A, B):
	return A*x + B

try:
# nacitanie suboru
	if("xlsx" in file):
		data = pd.read_excel(file) # pip3 install xlrd
	if("csv" in file):
		data = pd.read_csv(file)
	if("ods" in file):
		data = read_ods(file, 1) # pip3 install pandas_ods_reader

# vytvorenie poli, treba zadat nazvy stlpcov pre x,y,ey hodnoty rovnake ako su v tabulke
	data_X = np.array(data["x"])
	data_Y = np.array(data["y"])
	data_Err = np.array(data["ey"])

# fitovanie
	gmodel = Model(fit_funkcia)
	results = gmodel.fit(data_Y, x=data_X, A=1.8, B=1.0, weights=1.0/data_Err)
	print(results.fit_report())

# vekreslenie dat a chyb
	d = plt.scatter(data_X, data_Y, color="black", zorder=2)
	plt.errorbar(data_X, data_Y, yerr=data_Err, fmt=" ", zorder=1, ecolor="black", elinewidth=1.0)

# vykreslenie fitovacej funkcie
	f, = plt.plot(data_X, results.best_fit, c="red")

# pomenovanie grafu a osi
	plt.ylabel("Y-os")
	plt.xlabel("X-os")
	plt.title("Nazov grafu")

# legenda
	plt.legend([d, f],["data", "fit"], loc="upper left", shadow=True)

# ulozenie alebo vykreslenie grafu
	if(False): # True alebo False
		plt.savefig("myplot.pdf")
	else:
		plt.show()

except (ImportError, FileNotFoundError):
	print("Problem s nacitanim dokumentu !!!")